<?php

namespace AppBundle\Controller;

use AppBundle\Form\UserEditType;
use Symfony\Bundle\FrameworkBundle\Controller\Controller;
use Symfony\Component\HttpFoundation\Request;
use Symfony\Component\Routing\Annotation\Route;
use AppBundle\Form\UserType;
use AppBundle\Entity\User;
use Symfony\Component\Security\Core\Encoder\UserPasswordEncoderInterface;

class SecurityController extends Controller
{
    public function loginAction(Request $request)
    {
        if ($this->get('security.authorization_checker')->isGranted('IS_AUTHENTICATED_REMEMBERED')) {
            return $this->redirectToRoute('videotheque_liste');
        }

        $authenticationUtils = $this->get('security.authentication_utils');

        return $this->render('@App/security/login.html.twig', array (
            'last_username' =>  $authenticationUtils->getLastUsername(),
            'error'         =>  $authenticationUtils->getLastAuthenticationError()
        ));
    }

    /**
     * @Route("/admin/createuser", name="admin_createuser")
     */
    public function createUserAction(Request $request, UserPasswordEncoderInterface $encoder)
    {
        $user = new User;
        $form = $this->createForm(UserType::class, $user);

        $form->handleRequest($request);
        if ($form->isSubmitted() && $form->isValid())
        {
            $user = $form->getData();
            $encoded = $encoder->encodePassword($user, $user->getPassword());
            $user->setPassword($encoded);
            $em = $this->getDoctrine()->getManager();
            $em->persist($user);
            $em->flush();
            $this->addFlash('success', 'L\'utilisateur a été ajouté');
            return $this->redirectToRoute('videotheque_liste');
        }
        return $this->render('@App/security/createuser.html.twig', array (
            'form'  => $form->createView()
        ));
    }

    /**
     * @Route("/admin/edituser/{id}", name="admin_edituser")
     */
    public function editUserAction(Request $request, UserPasswordEncoderInterface $encoder, $id)
    {
        $em = $this->getDoctrine()->getManager();
        $repo = $em->getRepository('AppBundle:User');
        $user = $repo->find($id);

        $form = $this->createForm(UserEditType::class, $user);

        $form->handleRequest($request);
        if ($form->isSubmitted() && $form->isValid())
        {
            $user = $form->getData();
            //$encoded = $encoder->encodePassword($user, $user->getPassword());
            //$user->setPassword($encoded);
            $em->flush();
            $this->addFlash('success', 'L\'utilisateur a été ajouté');
            return $this->redirectToRoute('videotheque_liste');
        }
        return $this->render('@App/security/createuser.html.twig', array (
            'form'  => $form->createView()
        ));
    }


}